CHRT(1)

BEZEICHNUNG
chrt - die Echtzeitattribute eines Prozesses manipulieren

ÜBERSICHT

chrt [Optionen] Priorität Befehl Argument…

chrt [Optionen] -p [Priorität] PID

BESCHREIBUNG

chrt setzt oder ermittelt die Echtzeit-Scheduling-Attribute eines existierenden Prozesses mit der Kennung PID oder führt einen Befehl mit den angegebenen Attributen aus.

SCHEDULING-REGELN

-o, --other
    setzt die Scheduling-Regel auf SCHED_OTHER (zeitbasiertes Scheduling). Dies ist die Vorgabe unter Linux.

-f, --fifo
    setzt die Scheduling-Regel auf SCHED_FIFO (zuerst hinein - zuerst hinaus).

-r, --rr
    setzt die Scheduling-Regel auf SCHED_RR (Rundlauf-Scheduling, »round-robin«). Wenn keine Regel definiert ist, wird SCHED_RR als Vorgabe verwendet.

-b, --batch
    setzt die Scheduling-Regel auf SCHED_BATCH (Stapelverarbeitungsprozess-Scheduling). Linux-spezifisch, wird seit 2.6.16 unterstützt. Das Prioritäts-Argument muss auf Null gesetzt werden.

-i, --idle
    setzt die Scheduling-Regel auf SCHED_IDLE (Scheduling von Prozessen niedriger Priorität). Linux-spezifisch, wird seit 2.6.23 unterstützt. Das Prioritäts-Argument muss auf Null gesetzt werden.

-d, --deadline
    legt die Scheduling-Regel auf SCHED_DEADLINE fest (»sporadic task model deadline scheduling«). Linux-spezifisch, wird seit 3.14 unterstützt. Das Prioritäts-Argument muss auf Null gesetzt werden. Siehe auch --sched-runtime, --sched-deadline und --sched-period. Der Zusammenhang zwischen den vom Kernel verlangten Optionen ist Laufzeit <= deadline <= Periode. chrt kopiert period nach deadline, falls --sched-deadline nicht angegeben ist und deadline nach runtime, falls --sched-runtime nicht angegeben ist. Das bedeutet, dass mindestens --sched-period angegeben sein muss. Siehe sched(7) für weitere Details.

SCHEDULING-OPTIONEN

-T, --sched-runtime Nanosekunden
    gibt die Laufzeitparameter für die SCHED_DEADLINE-Regel an (Linux-spezifisch)

-P, --sched-period Nanosekunden
    gibt den Periodenparameter für die SCHED_DEADLINE-Regel an (Linux-spezifisch)

-D, --sched-deadline Nanosekunden
    gibt den Deadline-Parameter für die SCHED_DEADLINE-Regel an (Linux-spezifisch)

-R, --reset-on-fork
    verwendet den Schalter SCHED_RESET_ON_FORK oder SCHED_FLAG_RESET_ON_FORK. Linux-spezifisch, wird seit 2.6.31 unterstützt.

Jeder Thread hat einen Scheduling-Schalter reset-on-fork. Wenn dieser Schalter gesetzt ist, erben von fork(2) erzeugte Kindprozesse nicht die privilegierten Scheduling-Regeln. Nachdem der Schalter reset-on-fork aktiviert wurde, kann er nur zurückgesetzt werden, wenn der der Thread über die Capability CAP_SYS_NICE verfügt. Dieser Schalter ist in von fork(2) erzeugten Kindprozessen deaktiviert.

Genauer gesagt, falls der Schalter reset-on-fork gesetzt ist, werden die folgenden Regeln für nachfolgend erzeugte Kinder angewendet:

    • Falls die Scheduling-Regel des aufrufenden Threads auf SCHED_FIFO oder SCHED_RR gesetzt ist, wird die Regel in Kindprozessen auf SCHED_OTHER zurückgesetzt.

    • Falls der aufrufende Prozess einen negativen Nice-Wert hat, wird der Nice-Wert in Kindprozessen auf 0 zurückgesetzt.

OPTIONEN

-a, --all-tasks
    setzt oder ermittelt die Scheduling-Attribute aller Prozesse (Threads) für eine gegebene Kennung (PID).

-m, --max
    zeigt die minimal und maximal möglichen Prioritäten und beendet dann das Programm.

-p, --pid
    verwendet eine vorhandene Prozesskennung (PID), anstatt einen neuen Prozess zu starten.

-v, --verbose
    zeigt Statusinformationen an.

-h, --help
    zeigt einen Hilfetext an und beendet das Programm.

-V, --version
    zeigt die Versionsnummer an und beendet das Programm.

VERWENDUNG

Das Standardverhalten ist die Ausführung eines neuen Befehls:
    chrt Priorität Befehl [Argumente]

Sie können auch die Echtzeitattribute eines existierenden Prozesses ermitteln:
    chrt -p PID

Oder sie festlegen:
    chrt -r -p Priorität PID

ZUGRIFFSRECHTE

Ein Benutzer muss über CAP_SYS_NICE verfügen, um die Scheduling-Attribute eines Prozesses zu ändern. Die Ermittlung der Scheduling-Attribute ist allen Benutzern erlaubt.

ANMERKUNGEN

Nur SCHED_FIFO, SCHED_OTHER und SCHED_RR sind Teil des Prozess-Schedulings nach POSIX 1003.1b. Die anderen Scheduling-Attribute können auf einigen Systemen ignoriert werden.

Die unter Linux vorgegebene Scheduling-Regel ist SCHED_OTHER.

AUTOREN

SIEHE AUCH

nice(1), renice(1), taskset(1), sched(7)

In sched_setscheduler(2) finden Sie eine Beschreibung des Scheduling-Schemas in Linux.

FEHLER MELDEN

Verwenden Sie zum Melden von Fehlern das Fehlererfassungssystem auf

VERFÜGBARKEIT

Der Befehl chrt ist Teil des Pakets util-linux, welches heruntergeladen werden kann von:

ÜBERSETZUNG
Die deutsche Übersetzung dieser Handbuchseite wurde von Mario Blättermann <mario.blaettermann@gmail.com> erstellt.

Diese Übersetzung ist Freie Dokumentation; lesen Sie die GNU General Public License Version 3 (https://www.gnu.org/licenses/gpl-3.0.html) oder neuer bezüglich der Copyright-Bedingungen. Es wird KEINE HAFTUNG übernommen.

Wenn Sie Fehler in der Übersetzung dieser Handbuchseite finden, schicken Sie bitte eine E-Mail an die Mailingliste der Übersetzer (debian-l10n-german@lists.debian.org).